/**
 * Generated by Apache Royale Compiler from org/apache/royale/html/beads/DisableLoaderBead.as
 * org.apache.royale.html.beads.DisableLoaderBead
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.html.beads.DisableLoaderBead');

goog.require('org.apache.royale.core.IPopUpHost');
goog.require('org.apache.royale.core.IStrand');
goog.require('org.apache.royale.core.IUIBase');
goog.require('org.apache.royale.events.ValueEvent');
goog.require('org.apache.royale.geom.Point');
goog.require('org.apache.royale.html.LoadIndicator');
goog.require('org.apache.royale.html.beads.DisableBead');
goog.require('org.apache.royale.utils.PointUtils');
goog.require('org.apache.royale.utils.UIUtils');
goog.require('org.apache.royale.core.IBead');
goog.require('org.apache.royale.utils.Language');



/**
 *  constructor.
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.9.6
 * @constructor
 * @implements {org.apache.royale.core.IBead}
 */
org.apache.royale.html.beads.DisableLoaderBead = function() {
};


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.html.beads.DisableLoaderBead', org.apache.royale.html.beads.DisableLoaderBead);


/**
 * @protected
 * @type {org.apache.royale.core.IStrand}
 */
org.apache.royale.html.beads.DisableLoaderBead.prototype._strand;


/**
 * @protected
 * @type {org.apache.royale.core.IUIBase}
 */
org.apache.royale.html.beads.DisableLoaderBead.prototype._loader;


/**
 * @private
 * @param {org.apache.royale.events.ValueEvent} e
 */
org.apache.royale.html.beads.DisableLoaderBead.prototype.org_apache_royale_html_beads_DisableLoaderBead_disabledChangeHandler = function(e) {
  this.org_apache_royale_html_beads_DisableLoaderBead_updateHost(e.value);
};


/**
 * @private
 * @param {Object} value
 */
org.apache.royale.html.beads.DisableLoaderBead.prototype.org_apache_royale_html_beads_DisableLoaderBead_updateHost = function(value) {
  if (!this._strand)
    return;
  var /** @type {boolean} */ disabled;
  if (value == null) {
    var /** @type {org.apache.royale.html.beads.DisableBead} */ disableBead = org.apache.royale.utils.Language.as(this._strand.getBeadByType(org.apache.royale.html.beads.DisableBead), org.apache.royale.html.beads.DisableBead);
    if (!disableBead)
      return;
    disabled = disableBead.disabled;
  } else {
    disabled = !!(value);
  }
  if (disabled) {
    this.addLoadIndicator();
  } else if (this._loader) {
    this.removeLoadIndicator();
  }
};


/**
 * @protected
 */
org.apache.royale.html.beads.DisableLoaderBead.prototype.addLoadIndicator = function() {
  var /** @type {org.apache.royale.geom.Point} */ point = org.apache.royale.utils.PointUtils.localToGlobal(new org.apache.royale.geom.Point(0, 0), this.host);
  this._loader = new org.apache.royale.html.LoadIndicator();
  this._loader.x = point.x;
  this._loader.y = point.y;
  this._loader.width = this.host.width;
  this._loader.height = this.host.height;
  this._loader.element.style.position = "absolute";
  var /** @type {org.apache.royale.core.IPopUpHost} */ popupHost = org.apache.royale.utils.UIUtils.findPopUpHost(org.apache.royale.utils.Language.as(this._strand, org.apache.royale.core.IUIBase));
  popupHost.popUpParent.addElement(this._loader);
};


/**
 * @protected
 */
org.apache.royale.html.beads.DisableLoaderBead.prototype.removeLoadIndicator = function() {
  this._loader.parent.removeElement(this._loader);
};


org.apache.royale.html.beads.DisableLoaderBead.prototype.set__strand = function(value) {
  this._strand = value;
  this.host.addEventListener("disabledChange", org.apache.royale.utils.Language.closure(this.org_apache_royale_html_beads_DisableLoaderBead_disabledChangeHandler, this, 'disabledChangeHandler'));
  this.org_apache_royale_html_beads_DisableLoaderBead_updateHost(null);
};


org.apache.royale.html.beads.DisableLoaderBead.prototype.get__host = function() {
  return this._strand;
};


Object.defineProperties(org.apache.royale.html.beads.DisableLoaderBead.prototype, /** @lends {org.apache.royale.html.beads.DisableLoaderBead.prototype} */ {
/**
  * @export
  * @type {org.apache.royale.core.IStrand} */
strand: {
set: org.apache.royale.html.beads.DisableLoaderBead.prototype.set__strand},
/**
  * @export
  * @type {org.apache.royale.core.IUIBase} */
host: {
get: org.apache.royale.html.beads.DisableLoaderBead.prototype.get__host}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.html.beads.DisableLoaderBead.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'DisableLoaderBead', qName: 'org.apache.royale.html.beads.DisableLoaderBead', kind: 'class' }], interfaces: [org.apache.royale.core.IBead] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.html.beads.DisableLoaderBead.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {
      return {
        'strand': { type: 'org.apache.royale.core.IStrand', access: 'writeonly', declaredBy: 'org.apache.royale.html.beads.DisableLoaderBead'}
      };
    },
    methods: function () {
      return {
        'DisableLoaderBead': { type: '', declaredBy: 'org.apache.royale.html.beads.DisableLoaderBead'}
      };
    }
  };
};
/**
 * @export
 * @const
 * @type {number}
 */
org.apache.royale.html.beads.DisableLoaderBead.prototype.ROYALE_REFLECTION_INFO.compileFlags = 10;